var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { PureComponent } from 'react';
import { Form, Input, Select, Card, Icon, Tooltip, Button } from 'antd';

var FormItem = Form.Item;
var Option = Select.Option;

var InnerFormCoreFormsNew = function (_PureComponent) {
  _inherits(InnerFormCoreFormsNew, _PureComponent);

  function InnerFormCoreFormsNew() {
    var _temp, _this, _ret;

    _classCallCheck(this, InnerFormCoreFormsNew);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      loading: true,
      parents: [],
      parentId: null
    }, _this.fetch = function () {
      _this.setState({
        loading: true
      });
      _this.props.fetchParents(function (data) {
        _this.setState({
          loading: false,
          parents: data
        });
      });
    }, _this.handleSubmit = function (e) {
      e.preventDefault();
      _this.props.form.validateFieldsAndScroll(function (err, values) {
        if (!err) {
          _this.clearAjaxError(values);
          var h = _extends({}, values);
          if (h.ParentId) {
            h.ParentIds = [h.ParentId];
          } else {
            h.ParentIds = [];
          }
          delete h.ProductId;
          _this.props.submit(h);
        }
      });
    }, _this.clearAjaxError = function (origValues) {
      var fields = {
        Title: { value: origValues.Name, errors: null }
      };
      fields.ParentId = { value: origValues.ParentId, errors: null };
      _this.props.form.setFields(fields);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  InnerFormCoreFormsNew.prototype.componentDidMount = function componentDidMount() {
    this.fetch();
  };

  InnerFormCoreFormsNew.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch();
    }
  };

  InnerFormCoreFormsNew.prototype.render = function render() {
    var _this2 = this;

    var getFieldDecorator = this.props.form.getFieldDecorator;
    var _state = this.state,
        loading = _state.loading,
        parents = _state.parents,
        parentId = _state.parentId;


    var formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 7 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
        md: { span: 10 }
      }
    };

    var submitFormLayout = {
      wrapperCol: {
        xs: { span: 24, offset: 0 },
        sm: { span: 10, offset: 7 }
      }
    };

    var parent = null;
    if (parentId && parentId > 0) {
      parent = parents.find(function (x) {
        return x.Id === parentId;
      });
    }

    return React.createElement(
      Card,
      { bordered: false, loading: loading, title: 'New Product Offer' },
      React.createElement(
        Form,
        { onSubmit: this.handleSubmit, hideRequiredMark: true, style: { marginTop: 8 } },
        React.createElement(
          FormItem,
          _extends({}, formItemLayout, {
            help: this.props.parentsHelp,
            label: React.createElement(
              'span',
              null,
              'Based on\xA0',
              React.createElement(
                'em',
                { className: 'formcore_optional' },
                React.createElement(
                  Tooltip,
                  { title: 'The existing components and sections of the base will be referenced and never need to be created again.' },
                  React.createElement(Icon, { type: 'info-circle-o', style: { marginRight: 4 } })
                )
              )
            )
          }),
          getFieldDecorator('ParentId', {
            rules: [{ required: true, message: 'Please select an existing product offer' }]
          })(React.createElement(
            Select,
            {
              showSearch: true,
              onChange: function onChange(x) {
                return _this2.setState({ parentId: x });
              },
              placeholder: 'Select an existing product offer'
            },
            parents.map(function (x) {
              return React.createElement(
                Option,
                { key: x.Id, value: x.Id },
                x.Title
              );
            })
          ))
        ),
        React.createElement(
          FormItem,
          _extends({}, formItemLayout, {
            label: React.createElement(
              'span',
              null,
              'Title',
              React.createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              )
            )
          }),
          getFieldDecorator('Title', {
            initialValue: parent ? parent.Title : null
          })(React.createElement(Input, { placeholder: 'Title of the new product offer' }))
        ),
        React.createElement(
          FormItem,
          _extends({}, submitFormLayout, { style: { marginTop: 32 } }),
          React.createElement(
            Button,
            { htmlType: 'submit', type: 'primary' },
            'Submit'
          ),
          this.props.cancelButton
        )
      )
    );
  };

  return InnerFormCoreFormsNew;
}(PureComponent);

var FormCoreFormsNew = Form.create()(InnerFormCoreFormsNew);
export default FormCoreFormsNew;