'use strict';

exports.__esModule = true;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _RenderField = require('./RenderField');

var _RenderField2 = _interopRequireDefault(_RenderField);

var _InputStyle = require('./Constants/InputStyle');

var _InputStyle2 = _interopRequireDefault(_InputStyle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormCoreForm = function (_React$Component) {
  _inherits(FormCoreForm, _React$Component);

  function FormCoreForm() {
    var _temp, _this, _ret;

    _classCallCheck(this, FormCoreForm);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.getDefaultExpiredAtType = function () {
      var defaultValue = _this.props.data ? _this.props.data["ExpiredAtType"] : _lodash2['default'].find(_this.props.fields, function (x) {
        return x.Column === "ExpiredAtType";
      }).DefaultValue;
      defaultValue = defaultValue || "fixed";
      return defaultValue;
    }, _this.state = {
      expiredAtType: _this.getDefaultExpiredAtType()
    }, _this.handleExpiredAtTypeChange = function (e) {
      _this.setState({
        expiredAtType: e.target.value
      });
      if (e.target.value === 'indefinite') {
        _this.props.form.setFieldsValue({
          ExpiredAt: null
        });
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  FormCoreForm.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        form = _props.form,
        data = _props.data,
        sections = _props.sections,
        fields = _props.fields,
        renderExtra = _props.renderExtra,
        style = _props.style;

    var defaultValues = {};
    _lodash2['default'].each(fields, function (x) {
      defaultValues[x.Column] = x.DefaultValue;
    });
    return sections.map(function (x) {
      var localFields = _lodash2['default'].filter(fields, function (y) {
        return x.Id === y.SectionId;
      });
      if (x.ParentId > 0) {
        _lodash2['default'].forEach(_lodash2['default'].filter(fields, function (y) {
          return x.ParentId === y.SectionId;
        }), function (y) {
          if (undefined === _lodash2['default'].find(localFields, function (z) {
            return z.ParentId === y.Id;
          })) {
            localFields.push(y);
          }
        });
      }
      var visibleFields = _lodash2['default'].filter(localFields, function (f) {
        return f.InputStyle !== _InputStyle2['default'].Hidden;
      });
      localFields.sort(function (a, b) {
        return a.Position - b.Position;
      });
      var rowColContent = null;
      if (localFields.length === 1) {
        rowColContent = (0, _RenderField2['default'])(localFields[0], form, data, {}, renderExtra, _this2.state, { handleExpiredAtTypeChange: function handleExpiredAtTypeChange(e) {
            _this2.handleExpiredAtTypeChange(e);
          } });
      } else {
        rowColContent = _react2['default'].createElement(
          _antd.Row,
          { gutter: 16 },
          localFields.map(function (y) {
            return _react2['default'].createElement(
              _antd.Col,
              { lg: 8, md: 12, sm: 24, key: y.Id, hidden: _InputStyle2['default'].Hidden === y.InputStyle },
              (0, _RenderField2['default'])(y, form, data, {}, renderExtra, _this2.state, { handleExpiredAtTypeChange: function handleExpiredAtTypeChange(e) {
                  _this2.handleExpiredAtTypeChange(e);
                } })
            );
          })
        );
      }
      return _react2['default'].createElement(
        _antd.Card,
        {
          key: x.Id,
          title: x.Title,
          className: 'formcore_btm24',
          bordered: false,
          style: style,
          hidden: !(visibleFields && visibleFields.length > 0)
        },
        rowColContent
      );
    });
  };

  return FormCoreForm;
}(_react2['default'].Component);

exports['default'] = FormCoreForm;
module.exports = exports['default'];