'use strict';

exports.__esModule = true;

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _DescriptionList = require('ant-design-pro/lib/DescriptionList');

var _DescriptionList2 = _interopRequireDefault(_DescriptionList);

var _ShowField = require('./ShowField');

var _ShowField2 = _interopRequireDefault(_ShowField);

var _InputStyle = require('./Constants/InputStyle');

var _InputStyle2 = _interopRequireDefault(_InputStyle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormCoreShow = function (_React$Component) {
  _inherits(FormCoreShow, _React$Component);

  function FormCoreShow() {
    _classCallCheck(this, FormCoreShow);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  FormCoreShow.prototype.render = function render() {
    var _props = this.props,
        data = _props.data,
        sections = _props.sections,
        fields = _props.fields,
        showExtra = _props.showExtra,
        style = _props.style;

    var defaultValues = {};
    _lodash2['default'].each(fields, function (x) {
      defaultValues[x.Column] = x.DefaultValue;
    });
    return sections.map(function (x) {
      var localFields = _lodash2['default'].filter(fields, function (y) {
        return x.Id === y.SectionId;
      });
      if (x.ParentId > 0) {
        _lodash2['default'].forEach(_lodash2['default'].filter(fields, function (y) {
          return x.ParentId === y.SectionId;
        }), function (y) {
          if (undefined === _lodash2['default'].find(localFields, function (z) {
            return z.ParentId === y.Id;
          })) {
            localFields.push(y);
          }
        });
      }
      var visibleFields = _lodash2['default'].filter(localFields, function (f) {
        return f.InputStyle !== _InputStyle2['default'].Hidden;
      });
      localFields.sort(function (a, b) {
        return a.Position - b.Position;
      });
      var content = _lodash2['default'].filter(localFields.map(function (y) {
        return (0, _ShowField2['default'])(y, data, {}, showExtra);
      }), function (y) {
        return !!y;
      });
      return content.length > 0 ? _react2['default'].createElement(
        _DescriptionList2['default'],
        {
          key: x.Id,
          className: 'formcore_btm24',
          title: x.Title,
          style: style,
          hidden: !(visibleFields && visibleFields.length > 0)
        },
        content
      ) : null;
    });
  };

  return FormCoreShow;
}(_react2['default'].Component);

exports['default'] = FormCoreShow;
module.exports = exports['default'];