'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormItem = _antd.Form.Item;

var InnerFormCoreFormsEdit = function (_PureComponent) {
  _inherits(InnerFormCoreFormsEdit, _PureComponent);

  function InnerFormCoreFormsEdit() {
    var _temp, _this, _ret;

    _classCallCheck(this, InnerFormCoreFormsEdit);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      loading: true,
      entity: {}
    }, _this.fetch = function () {
      _this.setState({ loading: true });

      _this.props.fetch(function (entity) {
        var newEntity = _extends({ ParentId: entity.ParentIds[0] }, entity);
        _this.setState({ loading: false, entity: newEntity });
      });
    }, _this.handleSubmit = function (e) {
      e.preventDefault();
      _this.props.form.validateFieldsAndScroll(function (err, values) {
        if (!err) {
          _this.clearAjaxError(values);
          var newValues = _extends({ ParentIds: [values.ParentId] }, values);
          _this.props.submit(newValues);
        }
      });
    }, _this.clearAjaxError = function (origValues) {
      var fields = {
        Title: { value: origValues.Name, errors: null }
      };
      fields.ParentId = { value: origValues.Name, errors: null };
      _this.props.form.setFields(fields);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  InnerFormCoreFormsEdit.prototype.componentDidMount = function componentDidMount() {
    this.fetch();
  };

  InnerFormCoreFormsEdit.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch();
    }
  };

  InnerFormCoreFormsEdit.prototype.render = function render() {
    var getFieldDecorator = this.props.form.getFieldDecorator;
    var _state = this.state,
        loading = _state.loading,
        entity = _state.entity;


    var formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 7 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
        md: { span: 10 }
      }
    };

    var submitFormLayout = {
      wrapperCol: {
        xs: { span: 24, offset: 0 },
        sm: { span: 10, offset: 7 }
      }
    };

    return _react2['default'].createElement(
      _antd.Card,
      { bordered: false, loading: loading, title: entity.Title ? entity.Title : null },
      _react2['default'].createElement(
        _antd.Form,
        { onSubmit: this.handleSubmit, hideRequiredMark: true, style: { marginTop: 8 } },
        _react2['default'].createElement(
          FormItem,
          _extends({}, formItemLayout, {
            label: _react2['default'].createElement(
              'span',
              null,
              'Title',
              _react2['default'].createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              )
            )
          }),
          getFieldDecorator('Title', {
            rules: [{ required: true, message: 'Please enter the title of the new product offer' }],
            initialValue: entity.Title
          })(_react2['default'].createElement(_antd.Input, { placeholder: 'Title of the new product offer' }))
        ),
        _react2['default'].createElement(
          FormItem,
          _extends({}, submitFormLayout, { style: { marginTop: 32 } }),
          _react2['default'].createElement(
            _antd.Button,
            { htmlType: 'submit', type: 'primary' },
            'Submit'
          ),
          this.props.cancelButton
        )
      )
    );
  };

  return InnerFormCoreFormsEdit;
}(_react.PureComponent);

var FormCoreFormsEdit = _antd.Form.create()(InnerFormCoreFormsEdit);
exports['default'] = FormCoreFormsEdit;
module.exports = exports['default'];