'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

var _DescriptionList = require('ant-design-pro/lib/DescriptionList');

var _DescriptionList2 = _interopRequireDefault(_DescriptionList);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Description = _DescriptionList2['default'].Description;

var FormCoreFormsList = function (_Component) {
  _inherits(FormCoreFormsList, _Component);

  function FormCoreFormsList() {
    var _temp, _this, _ret;

    _classCallCheck(this, FormCoreFormsList);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      loading: true,
      forms: []
    }, _this.fetch = function () {
      _this.setState({
        loading: true
      });
      _this.props.fetch(function (data) {
        _this.setState({
          loading: false,
          forms: data
        });
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  FormCoreFormsList.prototype.componentDidMount = function componentDidMount() {
    this.fetch();
  };

  FormCoreFormsList.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch();
    }
  };

  FormCoreFormsList.prototype.render = function render() {
    var _this2 = this;

    var _state = this.state,
        loading = _state.loading,
        forms = _state.forms;

    return _react2['default'].createElement(
      _antd.Card,
      {
        className: 'formcore-card-button-fix',
        style: { marginBottom: 24 },
        title: 'Product Offers',
        bordered: false,
        extra: this.props.newFormButton,
        loading: loading
      },
      _react2['default'].createElement(
        _DescriptionList2['default'],
        { size: 'large' },
        forms && forms.length > 0 ? forms.map(function (x) {
          return _react2['default'].createElement(
            Description,
            { key: x.Id },
            _this2.props.formLink(x)
          );
        }) : _react2['default'].createElement(
          'div',
          { className: 'ant-list-empty-text', style: { paddingBottom: 32 } },
          'No data'
        )
      )
    );
  };

  return FormCoreFormsList;
}(_react.Component);

exports['default'] = FormCoreFormsList;
module.exports = exports['default'];