'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormItem = _antd.Form.Item;

var InnerFormCoreSectionsNew = function (_PureComponent) {
  _inherits(InnerFormCoreSectionsNew, _PureComponent);

  function InnerFormCoreSectionsNew() {
    var _temp, _this, _ret;

    _classCallCheck(this, InnerFormCoreSectionsNew);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _PureComponent.call.apply(_PureComponent, [this].concat(args))), _this), _this.state = {
      loading: true,
      form: {},
      parents: [],
      parentId: null
    }, _this.fetch = function (props) {
      _this.setState({
        loading: true
      });
      props.fetch(function (data0) {
        _this.setState({
          form: data0
        });
        if (data0.Parents.length > 0) {
          data0.Parents.forEach(function (form0) {
            props.fetchSpecific(form0.Id, function (data1) {
              _this.setState(function (prevState) {
                var oldParents = prevState.parents || [];
                return {
                  parents: oldParents.concat(data1.Sections),
                  loading: false
                };
              });
            });
          });
        } else {
          _this.setState({
            loading: false
          });
        }
      });
    }, _this.handleSubmit = function (e) {
      e.preventDefault();
      _this.props.form.validateFieldsAndScroll(function (err, values) {
        if (!err) {
          _this.props.submit(values);
        }
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  InnerFormCoreSectionsNew.prototype.componentDidMount = function componentDidMount() {
    this.fetch(this.props);
  };

  InnerFormCoreSectionsNew.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    var location = nextProps.location;
    var rawLocation = this.props.location;


    if (location.pathname !== rawLocation.pathname) {
      this.fetch(nextProps);
    }
  };

  InnerFormCoreSectionsNew.prototype.render = function render() {
    var _this2 = this;

    var getFieldDecorator = this.props.form.getFieldDecorator;
    var _state = this.state,
        loading = _state.loading,
        form = _state.form,
        parents = _state.parents,
        parentId = _state.parentId;


    var formItemLayout = {
      labelCol: {
        xs: { span: 24 },
        sm: { span: 7 }
      },
      wrapperCol: {
        xs: { span: 24 },
        sm: { span: 12 },
        md: { span: 10 }
      }
    };

    var submitFormLayout = {
      wrapperCol: {
        xs: { span: 24, offset: 0 },
        sm: { span: 10, offset: 7 }
      }
    };

    var parent = null;
    if (parentId && parentId > 0) {
      parent = parents.find(function (x) {
        return x.Id === parentId;
      });
    }

    return _react2['default'].createElement(
      _antd.Card,
      { bordered: false, loading: loading, title: 'New Section' },
      _react2['default'].createElement(
        _antd.Form,
        { onSubmit: this.handleSubmit, hideRequiredMark: true, style: { marginTop: 8 } },
        form && form.Parents && form.Parents.length > 0 ? _react2['default'].createElement(
          FormItem,
          _extends({}, formItemLayout, {
            help: _react2['default'].createElement(
              'span',
              null,
              this.props.providedBy(form)
            ),
            label: _react2['default'].createElement(
              'span',
              null,
              'Copy and Modify',
              _react2['default'].createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              ),
              '\xA0',
              _react2['default'].createElement(
                'em',
                { className: 'formcore_optional' },
                _react2['default'].createElement(
                  _antd.Tooltip,
                  { title: 'Select a section if you intend to copy and modify an existing section; otherwise leave it blank.' },
                  _react2['default'].createElement(_antd.Icon, { type: 'info-circle-o', style: { marginRight: 4 } })
                )
              )
            )
          }),
          getFieldDecorator('ParentId')(_react2['default'].createElement(
            _antd.Select,
            {
              allowClear: true,
              showSearch: true,
              placeholder: 'Select an existing section or leave it blank',
              onChange: function onChange(x) {
                return _this2.setState({ parentId: x });
              }
            },
            parents.map(function (x) {
              return _react2['default'].createElement(
                _antd.Select.Option,
                { key: x.Id, value: x.Id },
                x.Title
              );
            })
          ))
        ) : null,
        _react2['default'].createElement(
          FormItem,
          _extends({}, formItemLayout, {
            label: _react2['default'].createElement(
              'span',
              null,
              'Title',
              _react2['default'].createElement(
                'em',
                { className: 'formcore_optional' },
                ' (Optional)'
              )
            )
          }),
          getFieldDecorator('Title', {
            initialValue: parent ? parent.Title : null
          })(_react2['default'].createElement(_antd.Input, { placeholder: 'Title of the section' }))
        ),
        _react2['default'].createElement(
          FormItem,
          _extends({}, formItemLayout, {
            label: 'Position',
            help: 'The higher the number is, the lower on the page will the section be displayed.'
          }),
          getFieldDecorator('Position', {
            rules: [{
              required: true,
              message: 'Please enter the position of the section'
            }],
            initialValue: parent ? parent.Position : 0
          })(_react2['default'].createElement(_antd.InputNumber, { style: { width: '100%' } }))
        ),
        _react2['default'].createElement(
          FormItem,
          _extends({}, submitFormLayout, { style: { marginTop: 32 } }),
          _react2['default'].createElement(
            _antd.Button,
            { htmlType: 'submit', type: 'primary' },
            'Submit'
          ),
          this.props.cancelButton
        )
      )
    );
  };

  return InnerFormCoreSectionsNew;
}(_react.PureComponent);

var FormCoreSectionsNew = _antd.Form.create()(InnerFormCoreSectionsNew);
exports['default'] = FormCoreSectionsNew;
module.exports = exports['default'];